----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:25:16 04/30/2014 
-- Design Name: 
-- Module Name:    game - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity game is
    Port ( LED : out  STD_LOGIC_VECTOR (3 downto 0);
           CLK : in  STD_LOGIC;
			  winLed: out std_logic_vector(1 downto 0);
			  switch: in std_logic_vector(3 downto 0);
			  ErrorLED:  out std_logic_vector(1 downto 0));
           --Control : out  STD_LOGIC);
          -- Pointer : in  STD_LOGIC);
			 -- pointerLED: out std_logic_vector(2 downto 0));
end game;

architecture Behavioral of game is
type LIST  is ARRAY (10 downto 1) of std_logic_vector(3 downto 0);
Constant LISTEN: LIST := ("0010","0100","1000","0001","0100","0010","0010","0010","1000","0001"); 
begin
process(CLK)
variable prescaler: integer range 0 to 50000000;
Variable control: std_logic_vector(1 downto 0) := "00";
variable pointer: integer range 0 to 10:=0;
variable test: std_logic:='0';
variable error: std_logic:='0';
variable top_pointer: integer range 0 to 11 := 0;
variable buttontimer:  integer range 0 to 50000000 := 0;
begin
if rising_edge (clk) then 
			if control = "00" and error = '0' then 
				winLEd <= "00";
				errorLed <= "00";
					if(prescaler < 49999999/1) then 	
						prescaler := prescaler + 1;		
					else
						prescaler := 0;
						top_pointer := top_pointer + 1;  -- Top pointer increment
						control := "10";	--- trigger event to get to new state
						--test := '0';
					end if;
			end if;		
			
			if control = "10" then 
			winLED <= "10";
			errorLed <= "01";
				if prescaler < 49999999/1 then
					prescaler := prescaler + 1;
				else 
					prescaler := 0;
						if pointer < top_pointer then 
							LED <= conv_std_logic_vector(pointer,4);
							pointer := pointer + 1;
						else 
							pointer:= 0;
							control := "11";
						end if;	
				end if;		
			end if;
			
			
			
			
			
					if control = "11"  and error = '0' then 
						winLEd <= "11";
						errorLed <= "00";

					--	test := '0';
						if pointer-1>= (top_pointer) then 	-- If pointer is higher than toppointer, it means the sequence has to be incrementet. 
								LED <= "0000";
								control := "00";
								pointer := 0;
								test := '0';
								error:= '0';
								winLED <= "00";
								errorLed <= "11";	 

						end if;
						if switch = "0000"  then 								
									      errorLed <= "11";
											--LED <= conv_std_logic_vector(pointer+1,4);
											error:= '0';
											control := "11";
											--Led <= Listen(pointer+1);  
						end if;
						if switch /= "0000" then
								if switch = LISTEN(pointer+1) and (pointer-1) < top_pointer  then -- Checks if the switch match the sequence. 
									test := '1';
									buttontimer := buttontimer + 1;
									errorLed <= "10";	
										if switch = "0000" and test = '1' and buttontimer < 49999999/1 then
											pointer:= pointer +1;
											test := '0';
											buttontimer:= 0;
										end if;	

								end if;
								
								if switch /= LISTEN(pointer+1) and switch /= "0000"   and  (pointer-1) < top_pointer then  -- if it doesn not match, error will be set high => trigger an new state. 
									error:= '1';		
								end if;		
										
									
								if error = '1' then  -- stays here infinetly until board is reset. 
									errorLed <= "00";
									winLED <=  "01";
									Led <= switch;
								end if; 

						end if;	
					
					end if; 
				
end if;							
end process;
end Behavioral;

